<template>
  <div class="main-wrapper" @copy="onCopy" @paste="onPaste">
    <ob-main-template
      :top-level-members="currentMenu"
      :lang-icon="false"
      :unathorizedPage="isUnauthorizedPage"
      :contacts="contacts"
      @clickToObject="clickToObject"
      @on-load-user-data="setUserInfo"
      @logout="logout"
    >
      <div v-if="pathStyle==='gruzi'">
        <link rel="stylesheet" type="text/css" href="/gruzi_style.css" />
      </div>
      <div v-else>
        <link rel="stylesheet" type="text/css" href="/oboz_style.css" />
      </div>
      <!--@change-locale="onChangeLocale"-->
      <transition name="fadeIn">
        <Preloader v-if="isLoading" />
      </transition>

      <router-view />
    </ob-main-template>

    <Notify />
  </div>
</template>

<script>
  import VueCookie from 'vue-cookie'
  import obMainTemplate from 'common-components/src/obComponents/obMainTemplate'
  import Notify from "./services/Notifications/Notify.vue"
  import Preloader from '@/services/Preloader/Preloader'
  import { mapActions, mapMutations, mapState } from 'vuex'
  import { getCookie } from '@/utils/cookie'

  const hideMenuRoutes = ['entry', 'registration', 'login', 'confirm_email', 'restore', 'change-password', 'home'];
  const unauthorizedPages = ['unauthorized-tracking-map'];

  export default {
    name: 'App',
    data() {
      return {
        menu: null,
        currentComponentIndex: 0
      };
    },
    components: {
      obMainTemplate,
      Notify,
      Preloader,
    },

    created() {
      let link=document.createElement('link');
      link.href='/favicon_'+ this.pathStyle + '.png';
      link.rel='icon';
      document.getElementsByTagName('head')[0].appendChild(link)
      this.$eventGlobal.$on('getComponentId', this.setComponentId)
    },
    mounted () {
      if (getCookie('auth_token') && window.location.pathname !== '/signup') {
        this.fetchMenu()
      }
      this.setNotification(this.$notification)
    },
    beforeDestroy () {
      sessionStorage.setItem("userFunctionalRoles", null)
    },
    computed: {
      ...mapState({
        isLoadingMenu: state => state.functions.isLoading,
        topMenu: state => state.functions.topMenu
      }),
      isLoading() {
        return this.isLoadingMenu && !hideMenuRoutes.includes(this.$route.name) && !this.isUnauthorizedPage
      },
      currentMenu() {
        return !hideMenuRoutes.includes(this.$route.name) || (this.$route.name === 'registration' && this.topMenu.length) ? this.topMenu || [] : []
      },
      pathStyle() {
        return window.location.host.split('gruzi').length>1 ? 'gruzi': 'oboz'
      },
      contacts() {
        if (this.pathStyle === 'gruzi') {
          return {
            email: 'support@gruzi.ru',
            phone: '+7 (495) 260-17-78'
          }
        }

        return {}
      },
      isUnauthorizedPage() {
        return unauthorizedPages.includes(this.$route.name)
      },
    },

    methods: {
      ...mapActions({
        loadFuncs: 'functions/loadFuncs',
        fetchMenu: 'functions/fetchMenu'
      }),
      ...mapMutations({
        setUserInfo: 'user/setUserInfo',
        setMenu: 'functions/setMenu',
        setNotification: 'setNotification',
      }),
      onCopy(e) {
        e.preventDefault();
        const reg = new RegExp(/[A-Z]{2}\d{2}\s\d{3}\s\d{4}/);
        let text = window.getSelection().toString().replace(/\u200B/g, "");
        if (reg.test(text)) {
          text = text.replace(/\s/g, '')
        }
        const el = document.createElement('textarea');
        el.value = text;
        el.setAttribute('readonly', '');
        el.style.position = 'absolute';
        el.style.left = '-9999px';
        document.body.appendChild(el);
        const selected = document.getSelection().rangeCount > 0
            ? document.getSelection().getRangeAt(0)
            : false;
        el.select();
        document.execCommand('copy');
        document.body.removeChild(el);
        if (selected) {
          document.getSelection().removeAllRanges();
          document.getSelection().addRange(selected);
        }
      },
      onPaste(e) {
        const reg = new RegExp(/[A-Z]{2}\d{9}/);
        const text = (e.originalEvent || e).clipboardData.getData('text/plain');
        const active = document.activeElement;
        if (e.target === active && reg.test(text)) {
          e.stopPropagation();
          e.preventDefault();
          const formatted = text.replace(/([A-Z]{2}\d{2})(\d{3})(\d{4})/, '$1 $2 $3');
          document.execCommand("insertHTML", false, formatted);
        }
      },
      logout() {
        VueCookie.delete('auth_token');
        this.$router.push({ name: 'login' });
        this.setMenu([]);
      },
      setComponentId(data) {
        let path = window.location.pathname.split('/');

        path = path[2] ? path[2] : path[1];

        this.$eventGlobal.$emit('setComponentId', {
          uuid: data.uuid,
          id: `${ path }_${ data.tag }_${ this.currentComponentIndex++ }`
        })
      },
      clickToObject(data = {}) {
        if (data.type && data.type === 'href' && data.url) {
          this.$router.push(data.url)
        }
      }
      // onChangeLocale (lang) {
      // this.$store.dispatch("changeLocale", {
      //   lang: lang,
      //   page: this.$route.name
      // })
      // }
    }
  };
</script>

<style lang="scss" scoped>
  .main-wrapper {
    width: 100%;
    min-height: 100vh;
  }
</style>

<style lang="scss">
  //TODO Вынести в common-components
  @import "~common-components/src/static/css/variables";
  @import "~common-components/src/static/css/mixins";

  .spinner {
    position: absolute;
    top: 0;
    left: 0;
    right: 0;
    margin: auto;
    transition: opacity .3s ease;
    will-change: opacity;
    width: 100%;
    height: 100px;
    background: url('~@/assets/images/spinner.gif') center no-repeat $background-white;
    background-size: contain;

    &.hidden {
      opacity: 0;
      pointer-events: none;
    }
  }

  .risk-icon {
    @include font-mixin(11px, 5px, 400);
    width: 16px;
    height: 16px;
    border-radius: 50%;
    display: inline-flex;
    align-items: center;
    justify-content: center;
    text-align: center;
    cursor: default;
    flex: none;
  }

  /* Временные стили */
  .vdp-datepicker__calendar {
    min-width: 330px !important;
  }

  .preload-on {
    position: absolute;
    top: 0;
    left: 0;
    width: 100%;
    height: 100vh;
    overflow: hidden;
  }

  .fadeIn-enter {
    opacity: 1;
  }

  .fadeIn-leave-to {
    opacity: 0;
  }

  .fadeIn-enter-active,
  .fadeIn-leave-active {
    transition: opacity 0.2s linear;
  }

  .content-wrapper {
    width: 100%;
  }

  .content {
    position: relative;
  }

  .ob-layout-container.content {
    height: auto;
    min-height: calc(100vh - 148px);
  }

  .dx-icon.app-icon.app-icon--search {
    background: url(/src/static/icons/search_gray.svg) no-repeat 50% 50%;
  }

  .dx-row.dx-freespace-row {
    display: none;
  }

  .icon.ob-selector__list-item-icon,
  .icon.ob-selector__value-icon {
    &:before {
      width: 16px;
      height: 16px;
      display: inline-block;
      border-radius: 50%;
    }
  }

  .ob-order-template-header {
    z-index: 1;
  }

  .ob-order-template-header-left-number-content {
    white-space: nowrap;
    overflow: hidden;
    text-overflow: ellipsis;
    max-width: 130px;
  }

  .link-style {
    cursor: pointer;
    display: inline-block;
    margin: 0;
    padding: 0;
    border: none;
    background-color: transparent;
    outline: none;
    color: $color-blue-navy-blue;
    font-size: inherit;
    text-decoration: none;
  }

  .modal {
    &-small,
    &-sm {
      width: 440px !important;
    }

    &-medium,
    &-md {
      width: 660px !important;
    }

    &-large,
    &-bg {
      width: 880px !important;
    }

    &-extra-large,
    &-xl {
      width: 1100px !important;
    }

    &-max {
      width: calc(100% - 40px) !important;
    }

    .link-style {
      cursor: pointer;
      display: inline-block;
      margin: 0;
      padding: 0;
      border: none;
      background-color: transparent;
      outline: none;
      color: $color-blue-navy-blue;
      font-size: inherit;
    }

    &--hide-footer {
      .el-dialog__footer {
        display: none;
      }
    }

    &-footer {
      display: flex;
      justify-content: flex-end;
      align-items: center;
      margin-top: 30px;

      button + button {
        margin-left: 20px;
      }
    }
  }

  .el-dialog {
    margin: 0 auto !important;

    &:not(.reset-old-styles) {
      border-radius: 3px;

      &__header {
        padding: 40px 40px 10px !important;
      }

      &__footer {
        padding: 0 40px 40px !important;
      }

      &__body {
        padding: 10px 40px 20px !important;
      }
    }
  }

  .ob-data-grid-container {
    position: relative;
  }

  .d-f {
    display: flex;
  }

  .f-d-c {
    flex-direction: column;
  }

  .jc-sb {
    justify-content: space-between;
  }

  .jc-fs {
    justify-content: flex-start;
  }

  .jc-fe {
    justify-content: flex-end;
  }

  .al-i-c {
    align-items: center;
  }

  .icon[class*='risk-'] {
    font-size: 16px;
  }

  .body-bg {
    &-1 {
      background-size: cover;
      background-position: center center;
      background-image: url('./static/img/login_bg.svg');
    }

    &-2 {
      background-size: cover;
      background-position: center center;
      background-image: url('./static/img/reg_bg.svg');
    }
  }

  .h-100 {
    height: 100% !important;
  }

  .w-100 {
    width: 100% !important;
  }

  .left-form-container-wrapper {
    .content-wrapper {
      background-color: #ccc;
      width: 100%;
    }

    .fadeIn-enter,
    .fadeIn-leave-to {
      opacity: 0;
    }

    .fadeIn-enter-active,
    .fadeIn-leave-active {
      transition: opacity .3s ease-in-out;
    }

    .leftFormBg-enter,
    .leftFormBg-leave-to {
      opacity: 0.7;
    }

    .leftFormBg-enter-active,
    .leftFormBg-leave-active {
      transition: opacity .3s linear;
    }

    .toggle-height-enter-active,
    .toggle-height-leave-active {
      transition: all 0.4s;
      max-height: 999px;
    }

    .toggle-height-enter,
    .toggle-height-leave-to /* .fade-leave-active до версии 2.1.8 */
    {
      max-height: 0;
      opacity: 0;
    }

    .ob-layout-container {
      background-color: #ccc;
      display: flex;
      flex-direction: column;
      justify-content: flex-start;
      height: 100vh !important;

      & > .content {
        height: 100% !important;
      }

      .footer {
        display: none;
      }
    }

    .link-style {
      cursor: pointer;
      color: #004BC8 !important;
      text-decoration: none;
      letter-spacing: 0.4px;

      &:hover {
        text-decoration: underline;
      }
    }

    .input-error-bottom {
      @include font-mixin(12px, 1, 400, $color-error, 0.4px);
      margin-top: 15px;
    }

    input[type=number]::-webkit-inner-spin-button,
    input[type=number]::-webkit-outer-spin-button {
      -webkit-appearance: none;
      margin: 0;
    }

    .ml0 {
      margin-left: 0 !important;
    }

    .mb10 {
      margin-bottom: 10px !important;
    }

    .mb20 {
      margin-bottom: 20px !important;
    }

    .mb30 {
      margin-bottom: 30px !important;
    }

    .mb40 {
      margin-bottom: 40px !important;
    }

    .mt20 {
      margin-top: 20px !important;
    }

    .mt30 {
      margin-top: 30px !important;
    }

    .mt40 {
      margin-top: 40px !important;
    }
  }

  .color-error {
    color: $color-error!important;
  }

  .hardcode {
    outline: 1px solid red;
  }

  .app-logo {
    position: fixed;
  }
</style>
